Subject: RE: Special file names "." and ".." in READDIR response

From: "Noveck, Dave" <[email-masked]>
Date: Tue, 2 Nov 1999 19:30:44 -0800

> There has been an attempt to remove some of the specialness from the
> "." and ".." directory names in NFSv4.  However for Unix clients
> the "." and ".." entries need to be returned by READDIR and they
> need to be the first two entries in the directory.  The reason
> for this is that there is software that depends on this ordering.
> Unfortunately, the client can not insert the entries on its own
> because of the cookie values.  If the client were to insert
> the entries on its own it may end up duplicating cookie values
> returned by the server and this has potential for confusing the client
> and its application.
> 
> I would suggest that the protocol make a statement that the
> server insert the "." and ".." entries at the beginning of
> the READDIR response if they are not natively
> supported and describe them as aliases as they were in NFSv3.
> 
> 
> This also makes a stronger argument for removing LOOKUPP and
> specifying ".." as a special case for LOOKUP as has been 
> suggested before.

If all READDIR's have to return "." and "..", then you can't 
create files named "." and "..".  Dot and dot-dot are then
as special as they ever were.  LOOKUPP is then an "experiment
noble in purpose".  Let's get rid of it and move on.